﻿using Newtonsoft.Json;
using Syncfusion.EJ2.Base;
using Syncfusion.EJ2.FileManager.Base;
using Syncfusion.EJ2.FileManager.PhysicalFileProvider;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web.Hosting;
using System.Web.Mvc;
namespace EssentialJS2MvcApplication1.Controllers
{
    public partial class FileManagerController : Controller
    {
        public ActionResult FileManagerFeatures()
        {
            return View();
        }
        PhysicalFileProvider operation = new PhysicalFileProvider();
        public FileManagerController()

        {
            var path = HostingEnvironment.MapPath("~/Content/images/FileManager");
            this.operation.RootFolder(path);

        }
        public ActionResult FileActionDefault(FEParams args)

        {
            switch (args.action)

            {

                case "Read":
                    return Json(operation.ToCamelCase(operation.GetFiles(args.path, false)));

                case "Remove":

                    return Json(operation.ToCamelCase(operation.Remove(args.path, args.itemNames)));

                case "GetDetails":

                    return Json(operation.ToCamelCase(operation.GetDetails(args.path, args.itemNames)));

                case "CreateFolder":

                    return Json(operation.ToCamelCase(operation.CreateFolder(args.path, args.name)));

                case "Search":

                    return Json(operation.ToCamelCase(operation.Search(args.path, args.searchString, args.showHiddenItems, args.caseSensitive)));

                case "Rename":

                    return Json(operation.ToCamelCase(operation.Rename(args.path, args.name, args.itemNewName)));

            }

            return null;

        }
        public ActionResult Upload(string path, IList<System.Web.HttpPostedFileBase> uploadFiles, string action)
        {
            FileManagerResponse uploadResponse;
            uploadResponse = operation.Upload(path, uploadFiles, action, null);

            return Content("");
        }

        public ActionResult Download(string downloadInput)

        {
            FEParams args = JsonConvert.DeserializeObject<FEParams>(downloadInput);

            args.path = (args.path);

            return operation.Download(args.path, args.itemNames);

        }
        public ActionResult GetImage(FEParams args)

        {
            return this.operation.GetImage(args.path, false);
        }
        public class FEParams

        {
            public string action { get; set; }
            public string path { get; set; }
            public string targetPath { get; set; }
            public bool showHiddenItems { get; set; }
            public string[] itemNames { get; set; }

            public string name { get; set; }
            public bool caseSensitive { get; set; }

            public string[] CommonFiles { get; set; }
            public string searchString { get; set; }
            public string itemNewName { get; set; }

            public object[] data { get; set; }

        }
        public class RoleModel

        {
            public string action { get; set; }
        }
    }
}
